package org.omg.FT;

//
// Helper class for : Criteria
//
// @author OpenORB Compiler
//
public class CriteriaHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert Criteria into an any
	// @param	a an any
	// @param	t Criteria value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.Property[] t )
	{
		a.insert_Streamable( new org.omg.FT.CriteriaHolder( t ));
	}

	//
	// Extract Criteria from an any
	// @param	a an any
	// @return the extracted Criteria value
	//
	public static org.omg.FT.Property[] extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.CriteriaHolder)
					return ((org.omg.FT.CriteriaHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.CriteriaHolder h = new org.omg.FT.CriteriaHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the Criteria TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_alias_tc(id(),"Criteria",org.omg.FT.PropertiesHelper.type());
		}
		return _tc;
	}

	//
	// Return the Criteria IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/Criteria:1.0";

	//
	// Read Criteria from a marshalled stream
	// @param	istream the input stream
	// @return the readed Criteria value
	//
	public static org.omg.FT.Property[] read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.Property[] new_one;
		{
		int size1 = istream.read_ulong();
		new_one = new org.omg.FT.Property[size1];
		for ( int i1=0; i1<new_one.length; i1++)
		 {
			new_one[i1] = org.omg.FT.PropertyHelper.read(istream);

		 }
		}

		return new_one;
	}

	//
	// Write Criteria into a marshalled stream
	// @param	ostream the output stream
	// @param	value Criteria value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.Property[] value )
	{
		ostream.write_ulong(value.length);
		for ( int i1=0; i1<value.length; i1++)
		{
			org.omg.FT.PropertyHelper.write(ostream,value[i1]);

		}
	}

}
