package org.omg.FT;

//
// Helper class for : FactoryInfo
//
// @author OpenORB Compiler
//
public class FactoryInfoHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert FactoryInfo into an any
	// @param	a an any
	// @param	t FactoryInfo value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.FT.FactoryInfo t )
	{
		a.insert_Streamable( new org.omg.FT.FactoryInfoHolder( t ));
	}

	//
	// Extract FactoryInfo from an any
	// @param	a an any
	// @return the extracted FactoryInfo value
	//
	public static org.omg.FT.FactoryInfo extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.omg.FT.FactoryInfoHolder)
					return ((org.omg.FT.FactoryInfoHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.omg.FT.FactoryInfoHolder h = new org.omg.FT.FactoryInfoHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the FactoryInfo TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "the_factory";
				_members[0].type = org.omg.FT.GenericFactoryHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "the_location";
				_members[1].type = org.omg.FT.LocationHelper.type();
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "the_criteria";
				_members[2].type = org.omg.FT.CriteriaHelper.type();
				_tc = orb.create_struct_tc(id(),"FactoryInfo",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the FactoryInfo IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/FT/FactoryInfo:1.0";

	//
	// Read FactoryInfo from a marshalled stream
	// @param	istream the input stream
	// @return the readed FactoryInfo value
	//
	public static org.omg.FT.FactoryInfo read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.FT.FactoryInfo new_one = new org.omg.FT.FactoryInfo();

		new_one.the_factory = org.omg.FT.GenericFactoryHelper.read(istream);
		new_one.the_location = org.omg.FT.LocationHelper.read(istream);
		new_one.the_criteria = org.omg.FT.CriteriaHelper.read(istream);

		return new_one;
	}

	//
	// Write FactoryInfo into a marshalled stream
	// @param	ostream the output stream
	// @param	value FactoryInfo value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.FT.FactoryInfo value )
	{
		org.omg.FT.GenericFactoryHelper.write(ostream,value.the_factory);
		org.omg.FT.LocationHelper.write(ostream,value.the_location);
		org.omg.FT.CriteriaHelper.write(ostream,value.the_criteria);
	}

}
