/**
  * Redistribution and use of this software and associated
  * documentation ("Software"), with or without modification, are
  * permitted provided that the following conditions are met:
  *
  * 1. Redistributions of source code must retain copyright statements
  *    and notices.  Redistributions must also contain a copy of this
  *    document.
  *
  * 2. Redistributions in binary form must reproduce the above
  *    copyright notice, this list of conditions and the following
  *    disclaimer in the documentation and/or other materials provided
  *    with the distribution.
  *
  * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
  *    products derived from this Software without prior written
  *    permission of one of the parties involved in the TRANSORG project. For
  * 	  written permission, please contact diasz@ida.liu.se.
  *
  * 4. Products derived from this Software may not be called "TRANSORG"
  *    nor may "TRANSORG" appear in their names without prior written
  *    permission.
  *
  * 5. Due credit should be given to the TRANSORG Project
  *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
  *
  * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  * PARTICULAR PURPOSE ARE DISCLAIMED.
  *
  * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
  * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
  * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
  *
  * $Id: FaultMonitorL.java,v 1.0  diasz Exp $
  *
  * Date         Author  Changes
  */


package org.omg.FT;
import org.omg.CosNaming.*;
/** Class used to create (instantiate) a Fault Monitor object
 * @author <a href="mailto:diasz@ida.liu.se"> Diana Szentivanyi </a>
 * @version $Revision: 1.0 $ $Date:2003/06/23$
 */
public class FaultMonitorL{
    public static void main(String[] args){
	if(args.length<1) {
	    System.out.println("Wrong usage: please put fault tolerance domain");
	    System.exit(0);
	}

	String location=null;
	java.util.Properties props=System.getProperties();
	props.put("org.omg.CORBA.ORBClass","org.openorb.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass","org.openorb.CORBA.ORBSingleton");
	System.setProperties(props);
	ReplicationManager r_man;
	org.omg.CORBA.Object poa_o,rootNC_o,r_man_o;
	org.omg.PortableServer.POA poa;
	NamingContext rootNC,fmonNC;

	try{
	    location=java.net.InetAddress.getLocalHost().getHostName();
	}catch(java.net.UnknownHostException e){location=null;}

	int i;
	try{
	    org.omg.CORBA.ORB orb=org.omg.CORBA.ORB.init((String[])null,props);
	    poa_o=orb.resolve_initial_references("RootPOA");
	    poa=org.omg.PortableServer.POAHelper.narrow(poa_o);
	    NameComponent loc=new NameComponent(location,"directory"),loc_nc[]={loc};

	    FaultMonitor_impl inst_f;

	    r_man_o=orb.resolve_initial_references("ReplicationManager");
	    r_man=ReplicationManagerHelper.narrow(r_man_o);

	    FaultNotifier f_n=null;
	    while(true){
		f_n=r_man.get_fault_notifier();
		if(f_n!=null) {
		    inst_f=new FaultMonitor_impl(f_n,args[0],location,orb);
		    r_man.add_fault_monitor(new FaultMonitorInfo(inst_f._this(orb),loc_nc));
		    break;
		}
	    }
	    poa.the_POAManager().activate();
	    orb.run();
	}
	catch(Exception e){e.printStackTrace();}
    }
}
