package org.omg.FT;

//
// Interface definition : GenericFactory
//
// @author OpenORB Compiler
//
public class GenericFactoryPOATie extends GenericFactoryPOA
{

	//
	// Private reference to implementation object
	//
	private GenericFactoryOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public GenericFactoryPOATie( GenericFactoryOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public GenericFactoryPOATie( GenericFactoryOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public GenericFactoryOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( GenericFactoryOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation create_object
	//
	public org.omg.CORBA.Object create_object(String type_id, org.omg.FT.Property[] the_criteria, org.omg.CORBA.AnyHolder factory_creation_id)
		throws org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.InvalidProperty, org.omg.FT.CannotMeetCriteria
	{
		return _tie.create_object( type_id,  the_criteria,  factory_creation_id);
	}

	//
	// Operation delete_object
	//
	public void delete_object(org.omg.CORBA.Any factory_creation_id)
		throws org.omg.FT.ObjectNotFound
	{
		_tie.delete_object( factory_creation_id);
	}

	//
	// Operation activate_object
	//
	public void activate_object(org.omg.CORBA.Any factory_creation_id, long group_id, boolean first_time)
		throws org.omg.FT.ObjectNotFound
	{
		_tie.activate_object( factory_creation_id,  group_id,  first_time);
	}

	//
	// Operation install_gateway
	//
	public void install_gateway(org.omg.CORBA.Any factory_creation_id, org.omg.CORBA.Object gateway)
		throws org.omg.FT.ObjectNotFound
	{
		_tie.install_gateway( factory_creation_id,  gateway);
	}

	//
	// Operation get_load
	//
	public int get_load()
	{
		return _tie.get_load();
	}

	//
	// Operation add_new_type_id
	//
	public void add_new_type_id(String type_id, String class_name, String[] new_arg_class_n, java.lang.Object[] new_arg_values, org.omg.FT.MethSignStr[] methods)
	{
		_tie.add_new_type_id( type_id,  class_name,  new_arg_class_n,  new_arg_values,  methods);
	}

	//
	// Operation remove_type_id
	//
	public void remove_type_id(String type_id)
	{
		_tie.remove_type_id( type_id);
	}

	//
	// Operation modify_class_name_ti
	//
	public void modify_class_name_ti(String type_id, String new_class_name)
	{
		_tie.modify_class_name_ti( type_id,  new_class_name);
	}

	//
	// Operation modify_class_name_ti_ctr
	//
	public void modify_class_name_ti_ctr(String type_id, String new_class_name, String[] class_names, java.lang.Object[] arg_values)
	{
		_tie.modify_class_name_ti_ctr( type_id,  new_class_name,  class_names,  arg_values);
	}

	//
	// Operation add_new_method_type_id_s
	//
	public void add_new_method_type_id_s(String type_id, org.omg.FT.MethSignStr the_method)
	{
		_tie.add_new_method_type_id_s( type_id,  the_method);
	}

	//
	// Operation add_new_method_type_id_d
	//
	public void add_new_method_type_id_d(String type_id, String method_n, org.omg.CORBA.TypeCode[] par_types, org.omg.CORBA.TypeCode[] exc_types, int[] modes, char meth_type)
	{
		_tie.add_new_method_type_id_d( type_id,  method_n,  par_types,  exc_types,  modes,  meth_type);
	}

	//
	// Operation remove_method_type_id
	//
	public void remove_method_type_id(String type_id, String the_method)
	{
		_tie.remove_method_type_id( type_id,  the_method);
	}

	//
	// Operation modify_meth_type_id_add_param
	//
	public void modify_meth_type_id_add_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos)
	{
		_tie.modify_meth_type_id_add_param( type_id,  the_method,  par_type,  mode,  pos);
	}

	//
	// Operation modify_meth_type_id_add_exc
	//
	public void modify_meth_type_id_add_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos)
	{
		_tie.modify_meth_type_id_add_exc( type_id,  the_method,  exc_type,  pos);
	}

	//
	// Operation modify_meth_type_id_remove_param
	//
	public void modify_meth_type_id_remove_param(String type_id, String the_method, int pos)
	{
		_tie.modify_meth_type_id_remove_param( type_id,  the_method,  pos);
	}

	//
	// Operation modify_meth_type_id_remove_exc
	//
	public void modify_meth_type_id_remove_exc(String type_id, String the_method, int pos)
	{
		_tie.modify_meth_type_id_remove_exc( type_id,  the_method,  pos);
	}

	//
	// Operation modify_meth_type_id_modify_param
	//
	public void modify_meth_type_id_modify_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos)
	{
		_tie.modify_meth_type_id_modify_param( type_id,  the_method,  par_type,  mode,  pos);
	}

	//
	// Operation modify_meth_type_id_modify_exc
	//
	public void modify_meth_type_id_modify_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos)
	{
		_tie.modify_meth_type_id_modify_exc( type_id,  the_method,  exc_type,  pos);
	}

	//
	// Operation modify_meth_type_id_modify_type
	//
	public void modify_meth_type_id_modify_type(String type_id, String the_method, char new_type)
	{
		_tie.modify_meth_type_id_modify_type( type_id,  the_method,  new_type);
	}

}
