package org.omg.FT;

//
// Interface definition : ObjectGroupManager
//
// @author OpenORB Compiler
//
public abstract class ObjectGroupManagerPOA extends org.omg.PortableServer.Servant
		implements ObjectGroupManagerOperations, org.omg.CORBA.portable.InvokeHandler
{
	public ObjectGroupManager _this()
	{
		return ObjectGroupManagerHelper.narrow(_this_object());
	}

	public ObjectGroupManager _this( org.omg.CORBA.ORB orb )
	{
		return ObjectGroupManagerHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/ObjectGroupManager:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	private static java.util.Hashtable _ops_Hash = new java.util.Hashtable();
	static {
		_ops_Hash.put("create_member", new Integer(0) );
		_ops_Hash.put("add_member", new Integer(4) );
		_ops_Hash.put("remove_member", new Integer(8) );
		_ops_Hash.put("set_primary_member", new Integer(12) );
		_ops_Hash.put("locations_of_members", new Integer(16) );
		_ops_Hash.put("get_object_group_id", new Integer(20) );
		_ops_Hash.put("get_object_group_ref", new Integer(24) );
		_ops_Hash.put("get_group_ref", new Integer(28) );
		_ops_Hash.put("get_member_ref", new Integer(32) );
	};

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		Integer opidx = (Integer)_ops_Hash.get(opName);
		if(opidx == null)
			throw new org.omg.CORBA.BAD_OPERATION();

		switch(opidx.intValue()) {
		case 0:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);
			String arg2_in = org.omg.FT.TypeIdHelper.read(_is);
			org.omg.FT.Property[] arg3_in = org.omg.FT.CriteriaHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = create_member(arg0_in, arg1_in, arg2_in, arg3_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberAlreadyPresent _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberAlreadyPresentHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.NoFactory _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.NoFactoryHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.ObjectNotCreated _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotCreatedHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.InvalidCriteria _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidCriteriaHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.CannotMeetCriteria _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.CannotMeetCriteriaHelper.write(_output,_exception);
			}
			return _output;
		}
		case 4:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);
			org.omg.CORBA.Object arg2_in = _is.read_Object();

			try
			{
				org.omg.CORBA.Object _arg_result = add_member(arg0_in, arg1_in, arg2_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberAlreadyPresent _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberAlreadyPresentHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.ObjectNotAdded _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotAddedHelper.write(_output,_exception);
			}
			return _output;
		}
		case 8:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = remove_member(arg0_in, arg1_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 12:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = set_primary_member(arg0_in, arg1_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.PrimaryNotSet _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.PrimaryNotSetHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.BadReplicationStyle _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.BadReplicationStyleHelper.write(_output,_exception);
			}
			return _output;
		}
		case 16:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);

			try
			{
				org.omg.CosNaming.NameComponent[][] _arg_result = locations_of_members(arg0_in);

				_output = handler.createReply();
				org.omg.FT.LocationsHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 20:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);

			try
			{
				long _arg_result = get_object_group_id(arg0_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupIdHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 24:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = get_object_group_ref(arg0_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 28:
		{
			long arg0_in = org.omg.FT.ObjectGroupIdHelper.read(_is);

			org.omg.CORBA.Object _arg_result = get_group_ref(arg0_in);

			_output = handler.createReply();
			org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			return _output;
		}
		case 32:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = get_member_ref(arg0_in, arg1_in);

				_output = handler.createReply();
				_output.write_Object(_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		}

		// never reached
		throw new org.omg.CORBA.INTERNAL();
	}
}
