/**
  * Redistribution and use of this software and associated
  * documentation ("Software"), with or without modification, are
  * permitted provided that the following conditions are met:
  *
  * 1. Redistributions of source code must retain copyright statements
  *    and notices.  Redistributions must also contain a copy of this
  *    document.
  *
  * 2. Redistributions in binary form must reproduce the above
  *    copyright notice, this list of conditions and the following
  *    disclaimer in the documentation and/or other materials provided
  *    with the distribution.
  *
  * 3. The names "TRANSORG" or "EUTIST-AMI" must not be used to endorse or promote
  *    products derived from this Software without prior written
  *    permission of one of the parties involved in the TRANSORG project. For
  * 	  written permission, please contact diasz@ida.liu.se.
  *
  * 4. Products derived from this Software may not be called "TRANSORG"
  *    nor may "TRANSORG" appear in their names without prior written
  *    permission.
  *
  * 5. Due credit should be given to the TRANSORG Project
  *    (http://www.ida.liu.se/~rtslab/TRANSORG/).
  *
  * THIS SOFTWARE IS PROVIDED BY THE TRANSORG PROJECT CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  * PARTICULAR PURPOSE ARE DISCLAIMED.
  *
  * IN NO EVENT SHALL THE TRANSORG PROJECT CONTRIBUTORS
  * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
  * Copyright 2003 (C) TRANSORG Project Contributors All Rights Reserved.
  *
  * $Id: ReplicManagerL.java,v 1.0   Exp $
  *
  */

package org.omg.FT;
/** Class used to create (instantiate) the Replication Manager CORBA object
 * @author <a href="mailto:diasz@ida.liu.se"> Diana Szentivanyi </a>
 * @version $Revision: 1.0 $ $Date:2003/06/23$
 */
public class ReplicManagerL{
    public static void main(String args[]){

	if(args.length<3){
	    System.out.println("Usage: java org.omg.FT.ReplicManagerL ftDomName -ORBPort=2125  replication_manager classname");
	    return;
	}

	java.util.Properties props=System.getProperties();
	try{
	    props.put("org.omg.CORBA.ORBClass","org.openorb.CORBA.ORB");
	    props.put("org.omg.CORBA.ORBSingletonClass","org.openorb.CORBA.ORBSingleton");

	    System.setProperties(props);
	    org.omg.CORBA.Object poa_o;
	    org.omg.PortableServer.POA poa;

	    int i;

	    String[] args_h=new String[args.length+1];

	    for(i=0;i<args.length;i++)
		args_h[i]=args[i];

	    args_h[i]="-ORBProfile=excrmp";

	    org.omg.CORBA.ORB orb=org.omg.CORBA.ORB.init(args_h,props);
	    poa_o=orb.resolve_initial_references("RootPOA");
	    poa=org.omg.PortableServer.POAHelper.narrow(poa_o);
	    org.omg.FT.ReplicationManagerPOA inst=null;

	    try{
		java.lang.Class[] ctr_params_c=new java.lang.Class[3];
		ctr_params_c[0]=java.lang.Class.forName("org.omg.CORBA.ORB");
		ctr_params_c[1]=java.lang.Class.forName("org.omg.PortableServer.POA");
		ctr_params_c[2]=java.lang.Class.forName("java.lang.String");

		java.lang.Object[] ctr_params=new java.lang.Object[3];
		ctr_params[0]=orb;
		ctr_params[1]=poa;
		ctr_params[2]=args[0];

		java.lang.reflect.Constructor repl_m_c=java.lang.Class.forName(args[2]).getConstructor(ctr_params_c);
		java.lang.Object inst_dyn=repl_m_c.newInstance(ctr_params);
		inst=(org.omg.FT.ReplicationManagerPOA)inst_dyn;
	    }catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));inst=null;}
	    if(inst==null){System.out.println("Error with inst is null");System.exit(0);}

	    org.openorb.net.ServerManagerImpl server_manager = (org.openorb.net.ServerManagerImpl)((org.openorb.CORBA.ORB)orb).getFeature("ServerCPCManager");
	    org.openorb.adapter.fwd.ForwardAdapter default_adapter = new org.openorb.adapter.fwd.ForwardAdapter(server_manager);
	    try {
		org.openorb.adapter.ObjectAdapter defl = server_manager.find_adapter( new byte[0] );
		if(defl==null) System.out.println("adapter is null");
		if(defl instanceof org.openorb.adapter.fwd.ForwardAdapter){
		    default_adapter = (org.openorb.adapter.fwd.ForwardAdapter)defl;
		}
	    }
	    catch(Exception ex) {
		ex.printStackTrace();
	    }
	    if(default_adapter != null){
		default_adapter.put("ReplicationManager", inst._this(orb));
	    }
	    ((org.openorb.CORBA.ORB)orb).setFeature("ItsReplicationManager",inst);
	    poa.the_POAManager().activate();
	    orb.run();
	}catch(Exception e){e.printStackTrace();}
    }
}
