package org.omg.FT;

//
// Interface definition : ReplicationManager
//
// @author OpenORB Compiler
//
public abstract class ReplicationManagerPOA extends org.omg.PortableServer.Servant
		implements ReplicationManagerOperations, org.omg.CORBA.portable.InvokeHandler
{
	public ReplicationManager _this()
	{
		return ReplicationManagerHelper.narrow(_this_object());
	}

	public ReplicationManager _this( org.omg.CORBA.ORB orb )
	{
		return ReplicationManagerHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:omg.org/FT/ReplicationManager:1.0", 
		"IDL:omg.org/FT/PropertyManager:1.0", 
		"IDL:omg.org/FT/ObjectGroupManager:1.0", 
		"IDL:omg.org/FT/GenericFactory:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	private static java.util.Hashtable _ops_Hash = new java.util.Hashtable();
	static {
		_ops_Hash.put("add_logging_recovery_c", new Integer(0) );
		_ops_Hash.put("add_fault_monitor", new Integer(4) );
		_ops_Hash.put("register_fault_notifier", new Integer(8) );
		_ops_Hash.put("get_fault_notifier", new Integer(12) );
		_ops_Hash.put("set_default_properties", new Integer(16) );
		_ops_Hash.put("get_default_properties", new Integer(20) );
		_ops_Hash.put("remove_default_properties", new Integer(24) );
		_ops_Hash.put("set_type_properties", new Integer(28) );
		_ops_Hash.put("get_type_properties", new Integer(32) );
		_ops_Hash.put("remove_type_properties", new Integer(36) );
		_ops_Hash.put("set_properties_dynamically", new Integer(40) );
		_ops_Hash.put("get_properties", new Integer(44) );
		_ops_Hash.put("create_member", new Integer(48) );
		_ops_Hash.put("add_member", new Integer(52) );
		_ops_Hash.put("remove_member", new Integer(56) );
		_ops_Hash.put("set_primary_member", new Integer(60) );
		_ops_Hash.put("locations_of_members", new Integer(64) );
		_ops_Hash.put("get_object_group_id", new Integer(68) );
		_ops_Hash.put("get_object_group_ref", new Integer(72) );
		_ops_Hash.put("get_group_ref", new Integer(76) );
		_ops_Hash.put("get_member_ref", new Integer(80) );
		_ops_Hash.put("create_object", new Integer(84) );
		_ops_Hash.put("delete_object", new Integer(88) );
		_ops_Hash.put("activate_object", new Integer(92) );
		_ops_Hash.put("install_gateway", new Integer(96) );
		_ops_Hash.put("get_load", new Integer(100) );
		_ops_Hash.put("add_new_type_id", new Integer(104) );
		_ops_Hash.put("remove_type_id", new Integer(108) );
		_ops_Hash.put("modify_class_name_ti", new Integer(112) );
		_ops_Hash.put("modify_class_name_ti_ctr", new Integer(116) );
		_ops_Hash.put("add_new_method_type_id_s", new Integer(120) );
		_ops_Hash.put("add_new_method_type_id_d", new Integer(124) );
		_ops_Hash.put("remove_method_type_id", new Integer(128) );
		_ops_Hash.put("modify_meth_type_id_add_param", new Integer(132) );
		_ops_Hash.put("modify_meth_type_id_add_exc", new Integer(136) );
		_ops_Hash.put("modify_meth_type_id_remove_param", new Integer(140) );
		_ops_Hash.put("modify_meth_type_id_remove_exc", new Integer(144) );
		_ops_Hash.put("modify_meth_type_id_modify_param", new Integer(148) );
		_ops_Hash.put("modify_meth_type_id_modify_exc", new Integer(152) );
		_ops_Hash.put("modify_meth_type_id_modify_type", new Integer(156) );
	};

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		Integer opidx = (Integer)_ops_Hash.get(opName);
		if(opidx == null)
			throw new org.omg.CORBA.BAD_OPERATION();

		switch(opidx.intValue()) {
		case 0:
		{
			org.omg.FT.LoggingRecoveryControllerInfo arg0_in = org.omg.FT.LoggingRecoveryControllerInfoHelper.read(_is);

			add_logging_recovery_c(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 4:
		{
			org.omg.FT.FaultMonitorInfo arg0_in = org.omg.FT.FaultMonitorInfoHelper.read(_is);

			add_fault_monitor(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 8:
		{
			org.omg.FT.FaultNotifier arg0_in = org.omg.FT.FaultNotifierHelper.read(_is);

			register_fault_notifier(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 12:
		{

			try
			{
				org.omg.FT.FaultNotifier _arg_result = get_fault_notifier();

				_output = handler.createReply();
				org.omg.FT.FaultNotifierHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.InterfaceNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InterfaceNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 16:
		{
			org.omg.FT.Property[] arg0_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				set_default_properties(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		case 20:
		{

			org.omg.FT.Property[] _arg_result = get_default_properties();

			_output = handler.createReply();
			org.omg.FT.PropertiesHelper.write(_output,_arg_result);

			return _output;
		}
		case 24:
		{
			org.omg.FT.Property[] arg0_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				remove_default_properties(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		case 28:
		{
			String arg0_in = org.omg.FT.TypeIdHelper.read(_is);
			org.omg.FT.Property[] arg1_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				set_type_properties(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		case 32:
		{
			String arg0_in = org.omg.FT.TypeIdHelper.read(_is);

			org.omg.FT.Property[] _arg_result = get_type_properties(arg0_in);

			_output = handler.createReply();
			org.omg.FT.PropertiesHelper.write(_output,_arg_result);

			return _output;
		}
		case 36:
		{
			String arg0_in = org.omg.FT.TypeIdHelper.read(_is);
			org.omg.FT.Property[] arg1_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				remove_type_properties(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		case 40:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.FT.Property[] arg1_in = org.omg.FT.PropertiesHelper.read(_is);

			try
			{
				set_properties_dynamically(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.UnsupportedProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.UnsupportedPropertyHelper.write(_output,_exception);
			}
			return _output;
		}
		case 44:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);

			try
			{
				org.omg.FT.Property[] _arg_result = get_properties(arg0_in);

				_output = handler.createReply();
				org.omg.FT.PropertiesHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 48:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);
			String arg2_in = org.omg.FT.TypeIdHelper.read(_is);
			org.omg.FT.Property[] arg3_in = org.omg.FT.CriteriaHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = create_member(arg0_in, arg1_in, arg2_in, arg3_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberAlreadyPresent _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberAlreadyPresentHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.NoFactory _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.NoFactoryHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.ObjectNotCreated _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotCreatedHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.InvalidCriteria _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidCriteriaHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.CannotMeetCriteria _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.CannotMeetCriteriaHelper.write(_output,_exception);
			}
			return _output;
		}
		case 52:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);
			org.omg.CORBA.Object arg2_in = _is.read_Object();

			try
			{
				org.omg.CORBA.Object _arg_result = add_member(arg0_in, arg1_in, arg2_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberAlreadyPresent _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberAlreadyPresentHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.ObjectNotAdded _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotAddedHelper.write(_output,_exception);
			}
			return _output;
		}
		case 56:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = remove_member(arg0_in, arg1_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 60:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = set_primary_member(arg0_in, arg1_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.PrimaryNotSet _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.PrimaryNotSetHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.BadReplicationStyle _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.BadReplicationStyleHelper.write(_output,_exception);
			}
			return _output;
		}
		case 64:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);

			try
			{
				org.omg.CosNaming.NameComponent[][] _arg_result = locations_of_members(arg0_in);

				_output = handler.createReply();
				org.omg.FT.LocationsHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 68:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);

			try
			{
				long _arg_result = get_object_group_id(arg0_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupIdHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 72:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = get_object_group_ref(arg0_in);

				_output = handler.createReply();
				org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 76:
		{
			long arg0_in = org.omg.FT.ObjectGroupIdHelper.read(_is);

			org.omg.CORBA.Object _arg_result = get_group_ref(arg0_in);

			_output = handler.createReply();
			org.omg.FT.ObjectGroupHelper.write(_output,_arg_result);

			return _output;
		}
		case 80:
		{
			org.omg.CORBA.Object arg0_in = org.omg.FT.ObjectGroupHelper.read(_is);
			org.omg.CosNaming.NameComponent[] arg1_in = org.omg.FT.LocationHelper.read(_is);

			try
			{
				org.omg.CORBA.Object _arg_result = get_member_ref(arg0_in, arg1_in);

				_output = handler.createReply();
				_output.write_Object(_arg_result);

			}
			catch ( org.omg.FT.ObjectGroupNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectGroupNotFoundHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.MemberNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.MemberNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 84:
		{
			String arg0_in = org.omg.FT.TypeIdHelper.read(_is);
			org.omg.FT.Property[] arg1_in = org.omg.FT.CriteriaHelper.read(_is);
			org.omg.CORBA.AnyHolder arg2_out = new org.omg.CORBA.AnyHolder();

			try
			{
				org.omg.CORBA.Object _arg_result = create_object(arg0_in, arg1_in, arg2_out);

				_output = handler.createReply();
				_output.write_Object(_arg_result);

				org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.write(_output,arg2_out.value);
			}
			catch ( org.omg.FT.NoFactory _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.NoFactoryHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.ObjectNotCreated _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotCreatedHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.InvalidCriteria _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidCriteriaHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.InvalidProperty _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.InvalidPropertyHelper.write(_output,_exception);
			}
			catch ( org.omg.FT.CannotMeetCriteria _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.CannotMeetCriteriaHelper.write(_output,_exception);
			}
			return _output;
		}
		case 88:
		{
			org.omg.CORBA.Any arg0_in = org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.read(_is);

			try
			{
				delete_object(arg0_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.ObjectNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 92:
		{
			org.omg.CORBA.Any arg0_in = org.omg.FT.GenericFactoryPackage.FactoryCreationIdHelper.read(_is);
			long arg1_in = _is.read_longlong();
			boolean arg2_in = _is.read_boolean();

			try
			{
				activate_object(arg0_in, arg1_in, arg2_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.ObjectNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 96:
		{
			org.omg.CORBA.Any arg0_in = _is.read_any();
			org.omg.CORBA.Object arg1_in = _is.read_Object();

			try
			{
				install_gateway(arg0_in, arg1_in);

				_output = handler.createReply();

			}
			catch ( org.omg.FT.ObjectNotFound _exception )
			{
				_output = handler.createExceptionReply();
				org.omg.FT.ObjectNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		case 100:
		{

			int _arg_result = get_load();

			_output = handler.createReply();
			_output.write_long(_arg_result);

			return _output;
		}
		case 104:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			String[] arg2_in = org.omg.CORBA.StringSeqHelper.read(_is);
			java.lang.Object[] arg3_in = org.omg.FT.AbstractBaseSeqHelper.read(_is);
			org.omg.FT.MethSignStr[] arg4_in = org.omg.FT.MethSignStrsHelper.read(_is);

			add_new_type_id(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in);

			_output = handler.createReply();

			return _output;
		}
		case 108:
		{
			String arg0_in = _is.read_string();

			remove_type_id(arg0_in);

			_output = handler.createReply();

			return _output;
		}
		case 112:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();

			modify_class_name_ti(arg0_in, arg1_in);

			_output = handler.createReply();

			return _output;
		}
		case 116:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			String[] arg2_in = org.omg.CORBA.StringSeqHelper.read(_is);
			java.lang.Object[] arg3_in = org.omg.FT.AbstractBaseSeqHelper.read(_is);

			modify_class_name_ti_ctr(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 120:
		{
			String arg0_in = _is.read_string();
			org.omg.FT.MethSignStr arg1_in = org.omg.FT.MethSignStrHelper.read(_is);

			add_new_method_type_id_s(arg0_in, arg1_in);

			_output = handler.createReply();

			return _output;
		}
		case 124:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode[] arg2_in = org.omg.FT.TypeCodeSeqHelper.read(_is);
			org.omg.CORBA.TypeCode[] arg3_in = org.omg.FT.TypeCodeSeqHelper.read(_is);
			int[] arg4_in = org.omg.FT.longseqHelper.read(_is);
			char arg5_in = _is.read_char();

			add_new_method_type_id_d(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_in);

			_output = handler.createReply();

			return _output;
		}
		case 128:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();

			remove_method_type_id(arg0_in, arg1_in);

			_output = handler.createReply();

			return _output;
		}
		case 132:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode arg2_in = _is.read_TypeCode();
			int arg3_in = _is.read_long();
			int arg4_in = _is.read_long();

			modify_meth_type_id_add_param(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in);

			_output = handler.createReply();

			return _output;
		}
		case 136:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode arg2_in = _is.read_TypeCode();
			int arg3_in = _is.read_long();

			modify_meth_type_id_add_exc(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 140:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();

			modify_meth_type_id_remove_param(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();

			return _output;
		}
		case 144:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			int arg2_in = _is.read_long();

			modify_meth_type_id_remove_exc(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();

			return _output;
		}
		case 148:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode arg2_in = _is.read_TypeCode();
			int arg3_in = _is.read_long();
			int arg4_in = _is.read_long();

			modify_meth_type_id_modify_param(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in);

			_output = handler.createReply();

			return _output;
		}
		case 152:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			org.omg.CORBA.TypeCode arg2_in = _is.read_TypeCode();
			int arg3_in = _is.read_long();

			modify_meth_type_id_modify_exc(arg0_in, arg1_in, arg2_in, arg3_in);

			_output = handler.createReply();

			return _output;
		}
		case 156:
		{
			String arg0_in = _is.read_string();
			String arg1_in = _is.read_string();
			char arg2_in = _is.read_char();

			modify_meth_type_id_modify_type(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();

			return _output;
		}
		}

		// never reached
		throw new org.omg.CORBA.INTERNAL();
	}
}
