package org.omg.FT;

//
// Interface definition : ReplicationManager
//
// @author OpenORB Compiler
//
public class ReplicationManagerPOATie extends ReplicationManagerPOA
{

	//
	// Private reference to implementation object
	//
	private ReplicationManagerOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public ReplicationManagerPOATie( ReplicationManagerOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public ReplicationManagerPOATie( ReplicationManagerOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public ReplicationManagerOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( ReplicationManagerOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation add_logging_recovery_c
	//
	public void add_logging_recovery_c(org.omg.FT.LoggingRecoveryControllerInfo lrci)
	{
		_tie.add_logging_recovery_c( lrci);
	}

	//
	// Operation add_fault_monitor
	//
	public void add_fault_monitor(org.omg.FT.FaultMonitorInfo fmi)
	{
		_tie.add_fault_monitor( fmi);
	}

	//
	// Operation register_fault_notifier
	//
	public void register_fault_notifier(org.omg.FT.FaultNotifier fault_notifier)
	{
		_tie.register_fault_notifier( fault_notifier);
	}

	//
	// Operation get_fault_notifier
	//
	public org.omg.FT.FaultNotifier get_fault_notifier()
		throws org.omg.FT.InterfaceNotFound
	{
		return _tie.get_fault_notifier();
	}

	//
	// Operation set_default_properties
	//
	public void set_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.set_default_properties( props);
	}

	//
	// Operation get_default_properties
	//
	public org.omg.FT.Property[] get_default_properties()
	{
		return _tie.get_default_properties();
	}

	//
	// Operation remove_default_properties
	//
	public void remove_default_properties(org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.remove_default_properties( props);
	}

	//
	// Operation set_type_properties
	//
	public void set_type_properties(String type_id, org.omg.FT.Property[] overrides)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.set_type_properties( type_id,  overrides);
	}

	//
	// Operation get_type_properties
	//
	public org.omg.FT.Property[] get_type_properties(String type_id)
	{
		return _tie.get_type_properties( type_id);
	}

	//
	// Operation remove_type_properties
	//
	public void remove_type_properties(String type_id, org.omg.FT.Property[] props)
		throws org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.remove_type_properties( type_id,  props);
	}

	//
	// Operation set_properties_dynamically
	//
	public void set_properties_dynamically(org.omg.CORBA.Object object_group, org.omg.FT.Property[] overrides)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.InvalidProperty, org.omg.FT.UnsupportedProperty
	{
		_tie.set_properties_dynamically( object_group,  overrides);
	}

	//
	// Operation get_properties
	//
	public org.omg.FT.Property[] get_properties(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		return _tie.get_properties( object_group);
	}

	//
	// Operation create_member
	//
	public org.omg.CORBA.Object create_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, String type_id, org.omg.FT.Property[] the_criteria)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.CannotMeetCriteria
	{
		return _tie.create_member( object_group,  the_location,  type_id,  the_criteria);
	}

	//
	// Operation add_member
	//
	public org.omg.CORBA.Object add_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location, org.omg.CORBA.Object member)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberAlreadyPresent, org.omg.FT.ObjectNotAdded
	{
		return _tie.add_member( object_group,  the_location,  member);
	}

	//
	// Operation remove_member
	//
	public org.omg.CORBA.Object remove_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound
	{
		return _tie.remove_member( object_group,  the_location);
	}

	//
	// Operation set_primary_member
	//
	public org.omg.CORBA.Object set_primary_member(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] the_location)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound, org.omg.FT.PrimaryNotSet, org.omg.FT.BadReplicationStyle
	{
		return _tie.set_primary_member( object_group,  the_location);
	}

	//
	// Operation locations_of_members
	//
	public org.omg.CosNaming.NameComponent[][] locations_of_members(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		return _tie.locations_of_members( object_group);
	}

	//
	// Operation get_object_group_id
	//
	public long get_object_group_id(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		return _tie.get_object_group_id( object_group);
	}

	//
	// Operation get_object_group_ref
	//
	public org.omg.CORBA.Object get_object_group_ref(org.omg.CORBA.Object object_group)
		throws org.omg.FT.ObjectGroupNotFound
	{
		return _tie.get_object_group_ref( object_group);
	}

	//
	// Operation get_group_ref
	//
	public org.omg.CORBA.Object get_group_ref(long group_id)
	{
		return _tie.get_group_ref( group_id);
	}

	//
	// Operation get_member_ref
	//
	public org.omg.CORBA.Object get_member_ref(org.omg.CORBA.Object object_group, org.omg.CosNaming.NameComponent[] loc)
		throws org.omg.FT.ObjectGroupNotFound, org.omg.FT.MemberNotFound
	{
		return _tie.get_member_ref( object_group,  loc);
	}

	//
	// Operation create_object
	//
	public org.omg.CORBA.Object create_object(String type_id, org.omg.FT.Property[] the_criteria, org.omg.CORBA.AnyHolder factory_creation_id)
		throws org.omg.FT.NoFactory, org.omg.FT.ObjectNotCreated, org.omg.FT.InvalidCriteria, org.omg.FT.InvalidProperty, org.omg.FT.CannotMeetCriteria
	{
		return _tie.create_object( type_id,  the_criteria,  factory_creation_id);
	}

	//
	// Operation delete_object
	//
	public void delete_object(org.omg.CORBA.Any factory_creation_id)
		throws org.omg.FT.ObjectNotFound
	{
		_tie.delete_object( factory_creation_id);
	}

	//
	// Operation activate_object
	//
	public void activate_object(org.omg.CORBA.Any factory_creation_id, long group_id, boolean first_time)
		throws org.omg.FT.ObjectNotFound
	{
		_tie.activate_object( factory_creation_id,  group_id,  first_time);
	}

	//
	// Operation install_gateway
	//
	public void install_gateway(org.omg.CORBA.Any factory_creation_id, org.omg.CORBA.Object gateway)
		throws org.omg.FT.ObjectNotFound
	{
		_tie.install_gateway( factory_creation_id,  gateway);
	}

	//
	// Operation get_load
	//
	public int get_load()
	{
		return _tie.get_load();
	}

	//
	// Operation add_new_type_id
	//
	public void add_new_type_id(String type_id, String class_name, String[] new_arg_class_n, java.lang.Object[] new_arg_values, org.omg.FT.MethSignStr[] methods)
	{
		_tie.add_new_type_id( type_id,  class_name,  new_arg_class_n,  new_arg_values,  methods);
	}

	//
	// Operation remove_type_id
	//
	public void remove_type_id(String type_id)
	{
		_tie.remove_type_id( type_id);
	}

	//
	// Operation modify_class_name_ti
	//
	public void modify_class_name_ti(String type_id, String new_class_name)
	{
		_tie.modify_class_name_ti( type_id,  new_class_name);
	}

	//
	// Operation modify_class_name_ti_ctr
	//
	public void modify_class_name_ti_ctr(String type_id, String new_class_name, String[] class_names, java.lang.Object[] arg_values)
	{
		_tie.modify_class_name_ti_ctr( type_id,  new_class_name,  class_names,  arg_values);
	}

	//
	// Operation add_new_method_type_id_s
	//
	public void add_new_method_type_id_s(String type_id, org.omg.FT.MethSignStr the_method)
	{
		_tie.add_new_method_type_id_s( type_id,  the_method);
	}

	//
	// Operation add_new_method_type_id_d
	//
	public void add_new_method_type_id_d(String type_id, String method_n, org.omg.CORBA.TypeCode[] par_types, org.omg.CORBA.TypeCode[] exc_types, int[] modes, char meth_type)
	{
		_tie.add_new_method_type_id_d( type_id,  method_n,  par_types,  exc_types,  modes,  meth_type);
	}

	//
	// Operation remove_method_type_id
	//
	public void remove_method_type_id(String type_id, String the_method)
	{
		_tie.remove_method_type_id( type_id,  the_method);
	}

	//
	// Operation modify_meth_type_id_add_param
	//
	public void modify_meth_type_id_add_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos)
	{
		_tie.modify_meth_type_id_add_param( type_id,  the_method,  par_type,  mode,  pos);
	}

	//
	// Operation modify_meth_type_id_add_exc
	//
	public void modify_meth_type_id_add_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos)
	{
		_tie.modify_meth_type_id_add_exc( type_id,  the_method,  exc_type,  pos);
	}

	//
	// Operation modify_meth_type_id_remove_param
	//
	public void modify_meth_type_id_remove_param(String type_id, String the_method, int pos)
	{
		_tie.modify_meth_type_id_remove_param( type_id,  the_method,  pos);
	}

	//
	// Operation modify_meth_type_id_remove_exc
	//
	public void modify_meth_type_id_remove_exc(String type_id, String the_method, int pos)
	{
		_tie.modify_meth_type_id_remove_exc( type_id,  the_method,  pos);
	}

	//
	// Operation modify_meth_type_id_modify_param
	//
	public void modify_meth_type_id_modify_param(String type_id, String the_method, org.omg.CORBA.TypeCode par_type, int mode, int pos)
	{
		_tie.modify_meth_type_id_modify_param( type_id,  the_method,  par_type,  mode,  pos);
	}

	//
	// Operation modify_meth_type_id_modify_exc
	//
	public void modify_meth_type_id_modify_exc(String type_id, String the_method, org.omg.CORBA.TypeCode exc_type, int pos)
	{
		_tie.modify_meth_type_id_modify_exc( type_id,  the_method,  exc_type,  pos);
	}

	//
	// Operation modify_meth_type_id_modify_type
	//
	public void modify_meth_type_id_modify_type(String type_id, String the_method, char new_type)
	{
		_tie.modify_meth_type_id_modify_type( type_id,  the_method,  new_type);
	}

}
